﻿// <auto-generated />
using System;
using API.Data;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace API.Data.Migrations
{
    [DbContext(typeof(DataContext))]
    partial class DataContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.0")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("API.Models.Data.Branches", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("id");

                    b.Property<string>("CompareBranch")
                        .IsRequired()
                        .HasMaxLength(250)
                        .HasColumnType("character varying(250)")
                        .HasColumnName("compareBranch");

                    b.Property<string>("CompareBranchAliases")
                        .IsRequired()
                        .HasMaxLength(250)
                        .HasColumnType("character varying(250)")
                        .HasColumnName("compareBranchAliases");

                    b.Property<bool>("IsDefault")
                        .HasColumnType("boolean")
                        .HasColumnName("isDefault");

                    b.Property<string>("MainBranch")
                        .IsRequired()
                        .HasMaxLength(250)
                        .HasColumnType("character varying(250)")
                        .HasColumnName("mainBranch");

                    b.Property<string>("MainBranchAliases")
                        .IsRequired()
                        .HasMaxLength(250)
                        .HasColumnType("character varying(250)")
                        .HasColumnName("mainBranchAliases");

                    b.HasKey("Id");

                    b.ToTable("branches");
                });

            modelBuilder.Entity("API.Models.Data.Repositories", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("id");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(250)
                        .HasColumnType("character varying(250)")
                        .HasColumnName("name");

                    b.Property<string>("NodeId")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("nodeId");

                    b.Property<string>("Packages")
                        .IsRequired()
                        .HasMaxLength(1000)
                        .HasColumnType("character varying(1000)")
                        .HasColumnName("packages");

                    b.HasKey("Id");

                    b.ToTable("repositories");
                });

            modelBuilder.Entity("API.Models.Data.UserBranches", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("id");

                    b.Property<Guid>("branchId")
                        .HasColumnType("uuid");

                    b.Property<Guid>("userId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("branchId")
                        .IsUnique();

                    b.HasIndex("userId")
                        .IsUnique();

                    b.ToTable("userBranches");
                });

            modelBuilder.Entity("API.Models.Data.UserEntity", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("id");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("character varying(100)")
                        .HasColumnName("email");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("character varying(50)")
                        .HasColumnName("name");

                    b.Property<string>("NodeId")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("nodeId");

                    b.Property<string>("Packages")
                        .IsRequired()
                        .HasMaxLength(1000)
                        .HasColumnType("character varying(1000)")
                        .HasColumnName("packages");

                    b.Property<string>("Username")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("character varying(50)")
                        .HasColumnName("username");

                    b.Property<int>("VcsService")
                        .HasColumnType("integer")
                        .HasColumnName("vcsService");

                    b.HasKey("Id");

                    b.ToTable("user");
                });

            modelBuilder.Entity("API.Models.Data.UserRepository", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("id");

                    b.Property<Guid>("repositoryId")
                        .HasColumnType("uuid");

                    b.Property<Guid>("userId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("repositoryId")
                        .IsUnique();

                    b.HasIndex("userId")
                        .IsUnique();

                    b.ToTable("userRepositories");
                });

            modelBuilder.Entity("API.Models.Data.UserBranches", b =>
                {
                    b.HasOne("API.Models.Data.Branches", "Branch")
                        .WithOne("UserBranch")
                        .HasForeignKey("API.Models.Data.UserBranches", "branchId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("API.Models.Data.UserEntity", "User")
                        .WithOne("UserBranch")
                        .HasForeignKey("API.Models.Data.UserBranches", "userId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Branch");

                    b.Navigation("User");
                });

            modelBuilder.Entity("API.Models.Data.UserRepository", b =>
                {
                    b.HasOne("API.Models.Data.Repositories", "Repository")
                        .WithOne("UserRepository")
                        .HasForeignKey("API.Models.Data.UserRepository", "repositoryId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("API.Models.Data.UserEntity", "User")
                        .WithOne("Repository")
                        .HasForeignKey("API.Models.Data.UserRepository", "userId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Repository");

                    b.Navigation("User");
                });

            modelBuilder.Entity("API.Models.Data.Branches", b =>
                {
                    b.Navigation("UserBranch")
                        .IsRequired();
                });

            modelBuilder.Entity("API.Models.Data.Repositories", b =>
                {
                    b.Navigation("UserRepository")
                        .IsRequired();
                });

            modelBuilder.Entity("API.Models.Data.UserEntity", b =>
                {
                    b.Navigation("Repository")
                        .IsRequired();

                    b.Navigation("UserBranch")
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
